/*****************************************************************************
* $Id: HelpFrame.java,v 1.10 1998/07/21 22:10:25 jjung Exp $
*
* File: HelpFrame.java	Class: HelpFrame
* Goal: To provide a frame that display help information
*	Commands - Will tell you what all the commands do
*	About - give some information about the program	
******************************************************************************
******************************************************************************
By accessing this software, HELPFRAME, you are duly informed of and 
agree to be bound by the conditions described below in this notice:
 
This software product, HELPFRAME, is developed by Bradley Huffaker, and
Jaeyeon Jung copyrighted(C) 1998 by the University of California, 
San Diego (UCSD), with all rights reserved.  UCSD administers the NLANR 
Cache grants, NCR-9796082 and NCR-9616602, under which most of this code 
was developed.
 
There is no charge for HELPFRAME software. You can redistribute it and/or
modify it under the terms of the GNU General Public License, v. 2 dated
June 1991 which is incorporated by reference herein.  HELPFRAME is
distributed WITHOUT ANY WARRANTY, IMPLIED OR EXPRESS, OF
MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that the use of
it will not infringe on any third party's intellectual property
rights.
 
You should have received a copy of the GNU GPL along with the HELPFRAME
program.  Copies can also be obtained from
http://www.gnu.org/copyleft/gpl.html or by writing to
 
                        University of California, San Diego
                        SDSC/CAIDA/NLANR
                        9500 Gilman Dr., MS-0505
                        La Jolla, CA 92093 - 0505  USA
 
  Or contact INFO@NLANR.NET
*****************************************************************************/ 
package bhuffake.plankton;
import java.awt.*;

public class HelpFrame extends Frame
{

 static final int ABOUT = 0;
 final String ABOUT_STR =  
	"                       Plankton\n"+
	"                  A visualization of\n"+
	"             The NLANR Caching Hierarchy   \n"+
	"\n"+
	"                          by\n"+
	"\n"+
	"              Bradley Huffaker (01/17/98)\n"+
	"                  Jaeyeon Jung (03/18/98)\n"+
	"\n"+
	"        Cooperative Association for Internet\n"+
	"                     Data Analysis\n"+
	"        https://www.caida.org/Tools/Plankton/\n";

 static final int COMMANDS = 1;
/* It may sounds silly but plz keep the way writing COMMANDS_STR as it shows, 
    or helpJava2helpHtml.pl produces funcky output */
/* Start COMMANDS_STR */
 final String COMMANDS_STR = 
	"\n"+
	"File\n"+
	"======\n"+
	"  Clear Network\n"+
	"     Clears all nodes and lines that are currently displayed.\n"+
	"  Clear World Map\n"+
	"     Clears the world map that are currently displayed.\n"+
	"  Center Network\n"+
	"     Centers the viewing display on the location that is the \n"+
	"     average distance from all the nodes.\n"+
	"-------------------------------------------------------------------\n"+
	"  Load Network\n"+
	"     Searchs a directory (./Data for standalone, a URL for Applet)\n"+
	"     and then lists the files in a pop up window.  The user may\n"+
	"     then choose one to download. The applet only display `.fvl'\n"+
	"     files, while the standalone displays all files.\n"+
	"  Load World Map\n"+
	"     Loads a map when displaying in an geographical mode.\n"+
	"  Animation\n"+
	"     The user can choose multiple files and toggle between them\n"+
	"     by selecting file names listed.\n"+
	"-------------------------------------------------------------------\n"+
	"  Exit\n"+
	"     Exit from Plankton\n"+

	"\n"+
	"Build Tools\n"+
	"============\n"+
	"  Add Node\n"+
	"     Adds node to current network when the mouse is clicked inside\n"+
	"     the display.\n"+
	"  Add Line\n"+
	"     Add a line between two existing nodes. First click and hold\n"+
	"     down the button of the mouse over a node. Then drag the mouse \n"+
	"     over to another node. Then let the button go.\n"+
	"  Remove Object\n"+
	"     Move the mouse over either a line or a node and then click on\n"+
	"     and the object will be removed.\n"+
	"\n"+
 	"Interaction\n"+
	"============\n"+
	"  Select Object\n"+
	"     Allows the user to select nodes. Selected nodes will change\n"+
	"     there postions when the mouse button is held down and the \n"+
	"     mouse is dragged around inside of the display.\n"+
	"  Select Tree\n"+
	"     Select a node and all it's children. Where all it's children\n"+
	"     means those nodes which are placed below it in the format\n"+
	"     process.\n"+
	"  Deselect All Objects\n"+
	"     Deselects any selected nodes.\n"+
	"-------------------------------------------------------------------\n"+
	"  Select Root\n"+
	"     Changes a node into a root node or the other way around\n"+
	"     when the mouse is clicked on it.\n"+
	"  Select Root by Name\n"+
	"     Selects all nodes that contain a string in their name and\n"+
	"     Changes them into root nodes.\n"+
	"-------------------------------------------------------------------\n"+
	"  Move \n"+
	"     Will move the relative location of all the nodes when the user\n"+
	"     holds down the mouse and drags it around.\n"+
	"  Auto Arrange\n"+
	"     Attempts to place nodes in a tree which grows from the\n"+
	"     root nodes away from the center. This is done to all nodes.\n"+
	"  Step by Step \n"+
	"     Allows the user to see how hierarchy grows or shrinks from the\n"+
	"     roots one level at a time.\n"+
	"\n"+
	"View\n"+
	"=====\n"+
	"  Topological Arrange \n"+
	"     Places cache nodes according to their position in a NLANR\n"+
	"     caching hierarchy.\n"+
	"  Geographical Arrange \n"+
	"     Places cache nodes resolving their latitude and longitude \n"+
	"     if they are provided in the data files.\n"+
	"  Topological / Geographical \n"+
	"     Display both topological and geopraphical hierarchy\n"+
	"     at a screen.\n"+
	"-------------------------------------------------------------------\n"+
	"  Low resolution \n"+
	"     Represents peering relation as a line between nodes.\n"+
        "     (recommanded when move nodes)\n"+
	"  High resolution \n"+
	"     Represents peering relation as a triangluar line.\n"+
	"     (server: thick client:thin) \n"+
	"Tool\n"+
	"=====\n"+
	"  Zoom\n"+
	"     Will scale the current dimenions of the node locations\n"+
	"     by the amount indicated.\n"+
	"  Rotate\n"+
	"     Will rotate the currently displayed graph \n"+
	"     by the degree indicated (effective for topological one only).\n"+
	"  Line Size\n"+
	"     Adjust the thickness of lines drawn on the map\n"+
	"     by the amount indicated.\n"+
	"  Node Size\n"+
	"     Adjust the size of nodes drawn on the map\n"+
	"     by the amount indicated.\n"+
	"\n"+
	"Color by\n"+
	"=========\n"+
	"  Top Level Domain Name\n"+
	"     Will create a color scale and then color each node\n"+
	"     by the top level domain name.\n"+
	"  Mask/Color by HTTP Request\n"+ 
	"     Will create a color scale and then color each line and node\n"+ 
	"     by the number of HTTP requests it gets and allow users\n"+
	"     to highlight nodes or lines interested in.\n"+
	"  Default Colors\n"+ 
	"     Returns the line's an node's color to their defualt colors.\n"+
	"\n"+
	"Help\n"+
	"=====\n"+
	"  Commands\n"+
	"     This menu\n"+
	"  About\n"+
	"     Information about this program.\n"+
	"  Overview\n"+
	"     Some useful information about line and node charateristics.\n"+
	"-------------------------------------------------------------------\n";
/* End COMMANDS_STR */

 static final int OVERVIEW = 2;
 static final String OVERVIEW_STR = 
	"  General Overview\n"+
	"=======================\n"+
	"\n"+
	" Nodes\n"+
	"--------\n"+
	"   Red - root node\n"+
	"   Green - selected node\n"+
	"   Size - distance from a root\n"+
	"\n"+
	" Lines\n"+
	"--------\n"+
	"   Thick - at the server\n"+
	"   Thin  - at the client\n"+

	"\n"+
	" Applet vs. Standalone\n"+
	"-----------------------\n"+
	"  Speed - The standalone has much better preformace\n"+
	"  Download - The Applet auto load's the URL\n"+
	"  Source - The Applet are provided a URL\n"+
	"           The standalone looks in ./Data\n";
	
 // Holds the message
 TextArea area;
 // Used to make the window go away
 Button Cancel;

 public HelpFrame(int type)
 {
	super("Help");
	
 	area = new TextArea();
	area.setEditable(false);
	setType(type);

	Panel bottom_panel = new Panel();
	Cancel = new Button("Cancel");

	bottom_panel.setLayout(new FlowLayout());
	bottom_panel.add(Cancel);

	setLayout(new BorderLayout());
	add("Center",area);
	add("South",bottom_panel);
	pack();
 }

 public void setType(int type)
 {
	switch (type)
	{
		case ABOUT:    area.setText(ABOUT_STR) ; break;
		case COMMANDS: area.setText(COMMANDS_STR); break;
		case OVERVIEW: area.setText(OVERVIEW_STR); break;
		default: area.setText("Unknow type");
	}
 }

 public boolean handleEvent(Event event)
 {
	if (event.id == Event.ACTION_EVENT && event.target == Cancel)
		hide();
	return super.handleEvent(event);
 }
}